
#include "stc.h"
#include "stc32_stc8_usb.h"
#include "seg_led.h"
#include "beep.h"  
#include "time0.h"
#include "key.h"
#include "exit.h"
#include "adc.h"
#include "usart2.h"
#include "stdio.h"
#include "spi.h"
//#include "iic.h"
#include "pwm.h"
#include "stdlib.h"
#include "pid.h"
#include "MPU6050.h"
#include <math.H>
#include "intrins.h"



u8		edata	tp[16];
bit TIM_10ms_Flag;
uint Tme_CountDown=0;
float Motor1Speed=0.00;
uchar MPU6050_Data[14];
int Gyro_x,Gyro_y,Gyro_z;
int Acc_x,Acc_y,Acc_z;
int MPU6050_Temp;
int Gyro_angle_x=0,Gyro_angle_y=0,Gyro_angle_z=0;
int pwm=0;
int pwm_count;
int		edata g_x=0,g_y=0,g_z=0;					//ǽ
float	edata a_x=0,a_y=0;							//ǶȽ
float	edata AngleX=0,AngleY=0;					//Ԫŷ
float	edata Angle_gx=0,Angle_gy=0,Angle_gz=0;		//ɽٶȼĽ(Ƕ)
float	edata Angle_ax=0,Angle_ay=0,Angle_az=0;		//ɼٶȼļٶ()
//*********************************************************************
//****************Ƕȼ*********************************************
//*********************************************************************
#define	pi		3.14159265f                           
#define	Kp		0.8f                        
#define	Ki		0.001f                         
#define	halfT	0.004f           

float edata q0=1,q1=0,q2=0,q3=0;   
float edata exInt=0,eyInt=0,ezInt=0;  


void IMUupdate(float gx, float gy, float gz, float ax, float ay, float az)
{
	float edata norm;
	float edata vx, vy, vz;
	float edata ex, ey, ez;

	norm = sqrt(ax*ax + ay*ay + az*az);	//ѼٶȼƵάתɵά   
	ax = ax / norm;
	ay = ay / norm;
	az = az / norm;

		//	ǰԪɡҾеĵеԪء 
		//	ҾŷǵĶ壬ϵתϵԪ
		//	vx vy vzʵǵǰŷǣԪĻϵϣ
		//	λ
	vx = 2*(q1*q3 - q0*q2);
	vy = 2*(q0*q1 + q2*q3);
	vz = q0*q0 - q1*q1 - q2*q2 + q3*q3 ;

	ex = (ay*vz - az*vy) ;
	ey = (az*vx - ax*vz) ;
	ez = (ax*vy - ay*vx) ;

	exInt = exInt + ex * Ki;
	eyInt = eyInt + ey * Ki;
	ezInt = ezInt + ez * Ki;

	gx = gx + Kp*ex + exInt;
	gy = gy + Kp*ey + eyInt;
	gz = gz + Kp*ez + ezInt;

	q0 = q0 + (-q1*gx - q2*gy - q3*gz) * halfT;
	q1 = q1 + ( q0*gx + q2*gz - q3*gy) * halfT;
	q2 = q2 + ( q0*gy - q1*gz + q3*gx) * halfT;
	q3 = q3 + ( q0*gz + q1*gy - q2*gx) * halfT;

	norm = sqrt(q0*q0 + q1*q1 + q2*q2 + q3*q3);
	q0 = q0 / norm;
	q1 = q1 / norm;
	q2 = q2 / norm;
	q3 = q3 / norm;

	AngleX = asin(2*(q0*q2 - q1*q3 )) * 57.2957795f; //    ɶ
	AngleY = asin(2*(q0*q1 + q2*q3 )) * 57.2957795f; // 
}





//==============================================
//==============================================
//ƣdelay_ms
//ܣ뼶ʱ
//ڲuint ms
//أ
//ǰ汾VER1.0
//޸ڣ2023.2.28
//ǰߣĳ´
//ע
//===============================================
//===============================================
void delay_ms(uint ms)//һunsigned int  0-65536
{
    uint i;
    do{
        i=MAIN_Fosc/6000;
        while(--i);
      }
    while(--ms);
}
void sys_init();

//USBԼλ趨
char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;

char *USER_STCISPCMD = "@STCISP#";                      //ԶλISPûӿ
extern tPid pidMotor1Speed;
void main()
{ 
	sys_init();
    usb_init();
	Timer0_Init();
//	Timer1_Init();
	EUSB=1;
//	PWMA_Init();
//	PWMB_Init();
//	PID_init();

	InitMPU6050();
	delay_ms(1000);
	P40=0;
	EA=1; 	
	while(DeviceState != DEVSTATE_CONFIGURED);//ȴUSB
   while(1)
   {
	
		Read_MPU6050(tp);
	 
		P60=~P60;
		Angle_ax = ((float)(((int *)&tp)[0])) / 8192.0;	//ٶȴ	λ +- g
		Angle_ay = ((float)(((int *)&tp)[1])) / 8192.0;	//תϵ	8192 LSB/g, 1gӦ8192
		Angle_az = ((float)(((int *)&tp)[2])) / 8192.0;	//ٶ +-4g/S
		
		Angle_gx = ((float)(((int *)&tp)[4] )) / 65.5;	//Ǵ	λ +-
		Angle_gy = ((float)(((int *)&tp)[5] )) / 65.5;	// +-500/S, 1/ Ӧ 65.536
		Angle_gz = ((float)(((int *)&tp)[6] )) / 65.5;	//תϵ65.5 LSB/
		
		IMUupdate(Angle_gx*0.0174533f,Angle_gy*0.0174533f,Angle_gz*0.0174533f, Angle_ax,Angle_ay,Angle_az);
		printf(":%f \r\n",AngleX);
		delay_ms(50);

		

		
		}
	}

void sys_init()
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

    //====== USB ʼ ======
    P3M0 &= ~0x03;   //0000 0011
    P3M1 |= 0x03;    //0000 0011
    USBCON=0x00;
	USBCLK=0x00;
	IRC48MCR=0x00;
	delay_ms(10);
    IRC48MCR = 0x80;
    while (!(IRC48MCR & 0x01));
    
    USBCLK = 0x00; //CDCҪд룬HIDд
    USBCON = 0x90;
    //========================
}

void Timer0_Isr() interrupt 1
{
	static  timcount=0;
	 timcount++;
	Tme_CountDown++;
	if( timcount>=10)
	{
		timcount=0;
		TIM_10ms_Flag=1;

	}
//if(Tme_CountDown==2000)
//	{
//	Tme_CountDown=0;
//	PWMB_CR1=0x00;
//	Motor1Speed=(float)(Pulse)/442;
//	PWMB_CR1|=0x01;
//		PWMB_SMCR =0x00;
//		PWMB_CCER1=0x00;
//		PWMB_CCMR1=0x00;  //0110 1000 PWMģʽ1
//		PWMB_CCR5H=0;
//		PWMB_CCR5L=0;
//		PWMB_CCMR1=0x21;
//		PWMB_CCMR2=0x21;
//		PWMB_SMCR =0x03; 
//		PWMB_CCER1=0x33;
//		PWMB_CR1|=0x01;
		}
//	SEG_LED_Show();
//}
//void PWM_ISR() interrupt 26
//{
//	if (PWMB_SR1 & 0X02)				//1жϱ־1ʱ
//	{
//		cnt_H = PWMB_CCR5H;				//ȡPWM8λ		
//		cnt_L = PWMB_CCR5L;				//ȡPWM8λ
//		Encoder_Check();					//ֵ
//		PWMB_SR1 &= ~0X02;				//㲶1жϱ־
//	}
//}

