#include "eeprom.h"
#include "usart2.h"
//==================================================================================================
//==================================================================================================
//ƣvoid DisableEEPROM(void)
//ܣIAPλ
//ڲ
//أ
//ǰ汾VER1.0
//޸ڣ2023.2.28
//ǰߣĳ´
//ע
//==================================================================================================
//==================================================================================================
void DisableEEPROM(void)
{
    IAP_CONTR = 0;          //ر IAP 
    IAP_CMD = 0;            //Ĵ
    IAP_TRIG = 0;           //Ĵ
    IAP_ADDRE = 0xff;       //ַõ IAP 
    IAP_ADDRH = 0xff;       //ַõ IAP 
    IAP_ADDRL = 0xff;
}
//==================================================================================================
//==================================================================================================
//ƣchar EEPROM_read_n(u32 EE_address)
//ܣEEPROMȡһֽں
//ڲEE_addressȡַ
//أdatȡ
//ǰ汾VER1.0
//޸ڣ2023.2.28
//ǰߣĳ´
//ע
//==================================================================================================
//==================================================================================================
char EEPROM_read_n(u32 EE_address)
{
	char dat;
	EA = 0;     //ֹж
	IAP_CONTR = 0x80; //ʹ IAP
	IAP_TPS = Tip_Delay; //òȴ 24MHz
	IAP_CMD = 1;  // IAP 

	IAP_ADDRE = (u8)(EE_address >> 16); //͵ַֽڣַҪıʱ͵ַ
	IAP_ADDRH = (u8)(EE_address >> 8);  //͵ַֽڣַҪıʱ͵ַ
	IAP_ADDRL = (u8)EE_address;         //͵ַֽڣַҪıʱ͵ַ
	IAP_TRIG = 0x5a; //д(0x5a)
	IAP_TRIG = 0xa5; //д(0xa5)
	_nop_();   //STC32GǶ༶ˮߵָϵͳ4NOP֤IAP_DATA׼
	_nop_();
	_nop_();
	_nop_();
	dat = IAP_DATA; // IAP 
	DisableEEPROM();
	EA = 1;     //ж
	return dat;
}
//==================================================================================================
//==================================================================================================
//ƣvoid EEPROM_SectorErase(u32 EE_address)
//ܣַָEEPROM
//ڲEE_address:  ҪEEPROMĵַ
//أ
//ǰ汾VER1.0
//޸ڣ2023.2.28
//ǰߣĳ´
//ע
//==================================================================================================
//==================================================================================================
void EEPROM_SectorErase(u32 EE_address)
{
    EA = 0;     //ֹж

    IAP_CONTR = 0x80; //ʹ IAP
    IAP_TPS = Tip_Delay;     //òȴ 24MHz
    IAP_CMD = 3;      // IAP 
    IAP_ADDRE = (u8)(EE_address >> 16); //ַֽڣַҪıʱ͵ַ
    IAP_ADDRH = (u8)(EE_address >> 8);  //ַֽڣַҪıʱ͵ַ
    IAP_ADDRL = (u8)EE_address;         //ַֽڣַҪıʱ͵ַ
    IAP_TRIG = 0x5a; //д(0x5a)
    IAP_TRIG = 0xa5; //д(0xa5)
    _nop_();   //STC32GǶ༶ˮߵָϵͳ4NOP֤IAP_DATA׼
    _nop_();
    _nop_();
    _nop_();
    DisableEEPROM();
    EA = 1;     //ж
}
//==================================================================================================
//==================================================================================================
//ƣvoid EEPROM_write_n(u32 EE_address,u8 dat)
//ܣEEPROMָĵַдһֽ
//ڲ@EE_addressҪдݵEEPROMַ @datҪдEEPROM
//أ
//ǰ汾VER1.0
//޸ڣ2023.2.28
//ǰߣĳ´
//ע
//==================================================================================================
//==================================================================================================
void EEPROM_write_n(u32 EE_address,u8 dat)
{
    EA = 0;     //ֹж
    IAP_CONTR = 0x80; //ʹ IAP
    IAP_TPS = Tip_Delay; //òȴ 24MHz
    IAP_CMD = 2;  // IAP д
	IAP_ADDRE = (u8)(EE_address >> 16); //͵ַֽڣַҪıʱ͵ַ
	IAP_ADDRH = (u8)(EE_address >> 8);  //͵ַֽڣַҪıʱ͵ַ
	IAP_ADDRL = (u8)EE_address;         //͵ַֽڣַҪıʱ͵ַ
	IAP_DATA = dat; //д IAP 
	IAP_TRIG = 0x5a; //д(0x5a)
	IAP_TRIG = 0xa5; //д(0xa5)
	_nop_();   //STC32GǶ༶ˮߵָϵͳ4NOP֤IAP_DATA׼
	_nop_();
	_nop_();
	_nop_();
    DisableEEPROM();
    EA = 1;     //ж
}