
#include "config.h"
#include "MPU6050.H"

sbit    SCL = P2^5;		//IICʱŶ
sbit    SDA = P2^4;		//IICŶ

void  InitMPU6050(void);	//ʼMPU6050
void  Delay2us(void);
void  I2C_Start(void);
void  I2C_Stop(void);

bit   I2C_RecvACK(void);

void  I2C_SendByte(u8 dat);
u8	  I2C_RecvByte(void);

void  I2C_ReadPage(void);
void  I2C_WritePage(void);
u8	  Single_ReadI2C(u8 REG_Address);				//ȡI2C
void  Single_WriteI2C(u8 REG_Address,u8 REG_data);	//I2Cд

void Delay100ms()		//@24.000MHz
{
	unsigned long i;

	_nop_();
	_nop_();
	i = 599998UL;
	while (i) i--;
}

//I^CʱʱãμоƬֲ  6050ƼС1.3us ǻ⣬ʱʵ1.9us
void Delay2us(void)
{
	u8 i;
	i = 7;		// @24MHZ, 6 + 33 = 39T, 1.625us
	while (--i);
}

//**************************************
//I2Cʼź
//**************************************
void I2C_Start(void)
{
	Delay2us();                 //ʱ
	Delay2us();                 //ʱ
	SDA = 1;                    //
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	Delay2us();                 //ʱ
	SDA = 0;                    //½
	Delay2us();                 //ʱ
	SCL = 0;                    //ʱ
	Delay2us();                 //ʱ
}

//**************************************
//I2Cֹͣź
//**************************************
void I2C_Stop(void)
{
    Delay2us();                 //ʱ
    SDA = 0;                    //
    SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
    SDA = 1;                    //
	Delay2us();                 //ʱ
}

//**************************************
//I2CӦź
//**************************************
bit I2C_RecvACK(void)
{
	SDA = 1;
	Delay2us();                 //ʱ
    SCL = 1;                    //ʱ
    Delay2us();                 //ʱ
    CY = SDA;                   //Ӧź
    SCL = 0;                    //ʱ
    Delay2us();                 //ʱ
    return CY;
}

//**************************************
//I2C߷һֽ
//**************************************
void I2C_SendByte(u8 dat)
{
    u8 i;
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;              //Ƴݵλ
        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay2us();             //ʱ
        SCL = 0;                //ʱ
        Delay2us();             //ʱ
    }
    I2C_RecvACK();
}

//**************************************
//I2C߽һֽ
//**************************************
u8 I2C_RecvByte(void)
{
    u8 i;
    u8 dat = 0;
    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay2us();             //ʱ
        dat |= SDA;             //
        SCL = 0;                //ʱ
        Delay2us();             //ʱ
    }
    return dat;
}

//**************************************
//I2C豸дһֽ
//**************************************
void Single_WriteI2C(u8 REG_Address,u8 REG_data)
{
    I2C_Start();                  //ʼź
    I2C_SendByte(SlaveAddress);   //豸ַ+дź
    I2C_SendByte(REG_Address);    //ڲĴַ
    I2C_SendByte(REG_data);       //ڲĴݣ
    I2C_Stop();                   //ֹͣź
}
//**************************************
//I2C豸ȡһֽ
//**************************************
/*
u8 Single_ReadI2C(u8 REG_Address)
{
	u8 REG_data;
	I2C_Start();                   //ʼź
	I2C_SendByte(SlaveAddress);    //豸ַ+дź
	I2C_SendByte(REG_Address);     //ʹ洢Ԫַ0ʼ
	I2C_Start();                   //ʼź
	I2C_SendByte(SlaveAddress+1);  //豸ַ+ź
	REG_data=I2C_RecvByte();       //Ĵ
	
	SDA = 1;                    //дӦź
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	SCL = 0;                    //ʱ
	Delay2us();                 //ʱ
	
	I2C_Stop();                    //ֹͣź
	return REG_data;
}
*/

//**************************************
//ʼMPU6050
//**************************************
void InitMPU6050(void)
{
//	P2n_open_drain(0x30);	//P2.4 -- SDA,   P2.5 -- SCL
	Delay2us();
	Delay2us();
	Delay2us();
	Delay2us();
//	Single_WriteI2C(PWR_MGMT_1, 0x80);	//״̬
//	Delay100ms();
	Single_WriteI2C(PWR_MGMT_1, 0x00);	//״̬
	Single_WriteI2C(SMPLRT_DIV, 0x07);  //125hz
	Single_WriteI2C(CONFIG, 0x04);      //21HZ˲ ʱA8.5ms G8.3ms  ˴ȡֵӦ൱ע⣬ʱϵͳΪ
	Single_WriteI2C(GYRO_CONFIG, 0x08); //500/S 65.5LSB/g
	Single_WriteI2C(ACCEL_CONFIG, 0x08);//ٶ+-4g  8192LSB/g
}

void Read_MPU6050(u8 *buf)
{
	u8	i;
	
	I2C_Start();                  //ʼź
	I2C_SendByte(SlaveAddress);   //豸ַ+дź
	I2C_SendByte(ACCEL_XOUT_H);    //ڲĴַ
	I2C_Start();                   //ʼź
	I2C_SendByte(SlaveAddress+1);  //豸ַ+ź
	for(i=0; i<13; i++)
	{
		buf[i] = I2C_RecvByte();       //Ĵ
		SDA = 0;                    //дӦź
		SCL = 1;                    //ʱ
		Delay2us();                 //ʱ
		SCL = 0;                    //ʱ
		Delay2us();                 //ʱ
	}
		buf[i] = I2C_RecvByte();	//һֽ
		SDA = 1;                    //дӦź
		SCL = 1;                    //ʱ
		Delay2us();                 //ʱ
		SCL = 0;                    //ʱ
		Delay2us();                 //ʱ
	I2C_Stop();                    //ֹͣź
}
